Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB2EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB2EnergyEstimationPlugin.java	(revision 1253)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB2EnergyEstimationPlugin.java	(revision 1299)
@@ -9,18 +9,16 @@
 import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.airthroughput.UserAirThroughputStateName;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 import schedframe.resources.devices.Device;
+import schedframe.resources.devices.Fan;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 import simulator.ConfigurationOptions;
-import test.Node_Fan_Mapping;
 import example.energy.BaseEnergyEstimationPlugin;
 
 public class CB2EnergyEstimationPlugin extends BaseEnergyEstimationPlugin{
 
-	
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
 			PhysicalResource resource) {
-		
 		
 		double Pdc;
@@ -36,9 +34,6 @@
 		
 		/*********** Pload_dc ***********/
-		for(ComputingResource cr: room.getChildren()){
-			ComputeBox1 cb1 = (ComputeBox1)cr;
-			Pload_dc = Pload_dc + cb1.getPowerInterface().getRecentPowerUsage().getValue();
-		}
-		
+		Pload_dc = calculatePit(room);
+
 		
 		
@@ -46,21 +41,15 @@
 		
 		/*********** Pothers ***********/		
-		double a;//experiment
-		try{
-			a = ConfigurationOptions.alpha;
-		} catch (Exception e){
-			a = 0.02;
-		}
-		
-		//if not defined assume alpha = 0.02
-		if(a == -1)
-			a = 0.02;
-		
-		Pothers = a * Pload_dc; 
+		Pothers = calculatePothers(Pload_dc);
 		
 		
 		
 		/************* COOLING PART *************/
-		
+
+		
+		/*********** Pfans_dc ***********/
+		Pfans_dc = calculatePfans(room);
+		
+		/************ Pcooling_device ************/
 		Device coolingDevice = null;
 		for(Device device: room.getResourceCharacteristic().getDevices()){
@@ -72,94 +61,190 @@
 
 		
-		/*********** Pfans_dc ***********/
-		double ro = 1.168;//constant
-		double nf;//DEBB
-		try{
-			nf = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("CRAHFanEfficiency").get(0).getContent()).doubleValue();
-		} catch (Exception e){
-			nf = 0.6;
-		}
-		double delta_p;//from database, CFD
-		try{
-			delta_p = ConfigurationOptions.pressureDrop;
-		} catch (Exception e){
-			delta_p = -1;
-		}
-		
-		double Vair_total;
-		double mair_total;
-		
-		//in case of DCworms calculation of Vair_total
-		double mair_rack = 0;
-
+		double Pchiller = calculatePchiller(Pload_dc, Pfans_dc, Pothers, room);
+		double Pdry_cooler = calculatePdryCooler(Pload_dc, Pfans_dc, Pothers, room);
+		
+		double delta_Th_ex;//DEBB
+		try{
+			delta_Th_ex = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("deltaThEx").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			delta_Th_ex = 10;
+		}
+
+		double delta_Th_dry_cooler;//DEBB
+		try{
+			delta_Th_dry_cooler = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("deltaThDryCooler").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			delta_Th_dry_cooler = 10;
+		}
+		
+		double Tamb;//experiment
+		try{
+			Tamb = ConfigurationOptions.coolingData.getAmbientAirTempeature();
+		} catch (Exception e){
+			Tamb = -1;
+		}
+
+		double Tr_out;//from database, CFD
+		try{
+			Tr_out = ConfigurationOptions.coolingData.getOutletRoomAirTempeature();
+		} catch (Exception e){
+			Tr_out = -1;
+		}
+		
+		double Tr_in;//experiment
+		try{
+			Tr_in = ConfigurationOptions.coolingData.getInletRoomAirTempeature();
+		} catch (Exception e){
+			Tr_in = -1;
+		}
+
+		double Tev = Tr_in - delta_Th_ex;
+
+		
+		//if data not present in DB than don't take Pchiller into account
+		if(Tr_in != -1 && Tr_out != -1) {
+			if(Tamb != -1 && Tev - Tamb > 0 && delta_Th_dry_cooler < Tev - Tamb)
+				Pcooling_device = Pdry_cooler;
+			else
+				Pcooling_device = Pchiller;	
+		}
+		
+
+		Pdc = Pload_dc + Pothers + Pfans_dc + Pcooling_device;
+		//System.out.println("---");
+		//System.out.println("Pdry_cooler: " + Pdry_cooler + " Pchiller: "+ Pchiller);
+		//System.out.println("Pdc: " + Pdc + " Pload_dc: "+ Pload_dc + " Pothers: " + Pothers + " Pfans_dc: " + Pfans_dc + " Pcooling_device: " + Pcooling_device);
+		
+		//System.out.println("CB2 heat: " + Qload_dc + "; " + Qothers + "; " + Qfans_dc + "; " + Qdc);
+		//System.out.println("CB2 power: " + Pload_dc + "; " + Pothers + "; " + Pfans_dc + "; " + Pcooling_device + "; " + Pdc);
+
+		return Pdc;
+	}
+	
+	private double calculatePit(ComputingResource room){
+		double Pload_dc = 0;
 		for(ComputingResource cr: room.getChildren()){
 			ComputeBox1 cb1 = (ComputeBox1)cr;
-			for(NodeGroup nodeGroup: cb1.getNodesGroups()){
-				for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
-					if(device.getType().equals(StandardResourceType.Outlet)){
-						double mair_recs = 0;
-						double Vair_recs = 0;
-						
-						double Vair_recs1 = 0;
-						/*try {
-							Vair_recs1  = device.getAirThroughputInterface().getAirFlow(device.getAirThroughputInterface().getAirThroughputState());
-						} catch (NoSuchFieldException e) {
+			Pload_dc = Pload_dc + cb1.getPowerInterface().getRecentPowerUsage().getValue();
+		}
+		return Pload_dc;
+	}
+	
+	private double calculatePothers(double Pload_dc){
+		
+		double Pothers = 0;
+		
+		double a;//experiment
+		try{
+			a = ConfigurationOptions.coolingData.getAlpha();
+		} catch (Exception e){
+			a = 0.2;
+		}
+
+		Pothers = a * Pload_dc;
+		return Pothers;
+	}
+	
+	private double calculatePfans(ComputingResource room){
+		
+		double Pfans_dc = 0;
+
+		Device coolingDevice = null;
+		for(Device device: room.getResourceCharacteristic().getDevices()){
+			if(device.getType().equals(StandardResourceType.CoolingDevice)){
+				coolingDevice = device;
+				break;
+			}
+		}
+		
+		double nf;//DEBB
+		try{
+			nf = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("CRAHFanEfficiency").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			nf = 0.6;
+		}
+		double delta_p;//from database, CFD
+		double Vair_total;
+		
+		delta_p = ConfigurationOptions.coolingData.getPressureDrop();
+		Vair_total = ConfigurationOptions.coolingData.getAirFlowVolume();
+		
+		if(delta_p != -1 && Vair_total != -1)
+			Pfans_dc = delta_p * Vair_total / nf;
+		else {
+			
+			double ro = 1.168;//constant
+		
+			double mair_total;
+			
+			double mair_rack = 0;
+
+			for(ComputingResource cr: room.getChildren()){
+				ComputeBox1 cb1 = (ComputeBox1)cr;
+				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
+					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Outlet)){
+							
+							Fan fan = (Fan) device;
+							double mair_recs = 0;
+							double Vair_recs = 0;
+							
+							double Vair_recs1 = 0;
+
+							Vair_recs1  = fan.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+							double Vair_recs2 = 0;
+							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
+								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){
+
+									Vair_recs2  = device2.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+									break;
+								}
+							}	
+
+							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
+
+							mair_recs = Vair_recs * ro;
+							mair_rack  = mair_rack + mair_recs;
 						}
-						*/
-						if(device.getAirThroughputInterface().getAirThroughputState().getName().equals(new UserAirThroughputStateName("1").getName())){
-							Vair_recs1 = CoolEmAllTestbedMeasurements.SINGLE_FAN_OFF_AIR_FLOW;
-						} else {
-							Vair_recs1 = CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_AIR_FLOW;
-						}
-						double Vair_recs2 = 0;
-						for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
-							if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(device.getFullName().replace("Outlet", "Inlet"))){
-								/*try {
-									Vair_recs2  = device2.getAirThroughputInterface().getAirFlow(device2.getAirThroughputInterface().getAirThroughputState());
-								} catch (NoSuchFieldException e) {
-								}
-								*/
-								if(device2.getAirThroughputInterface().getAirThroughputState().getName().equals(new UserAirThroughputStateName("1").getName())){
-									Vair_recs2 = CoolEmAllTestbedMeasurements.SINGLE_FAN_OFF_AIR_FLOW;
-								} else {
-									Vair_recs2 = CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_AIR_FLOW;
-								}
-								break;
-							}
-						}	
-
-						Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
-
-						mair_recs = Vair_recs * ro;
-						mair_rack  = mair_rack + mair_recs;
 					}
 				}
 			}
-		}
-		mair_total = mair_rack;
-		Vair_total = mair_total / ro;
-		
-		//in case of CFD calculation of Vair_total
-		try{
-			Vair_total = ConfigurationOptions.airFlowVolume;
-		} catch (Exception e){
-			Vair_total = 0;
-		}
-		mair_total = Vair_total * ro;
-		
-		//if data not present in DB than don't take Pfans_dc into account
-		if(delta_p != -1 && Vair_total != -1)
-			Pfans_dc = delta_p * Vair_total / nf;
-		
-		
-		
-		/************ Pcooling_device ************/
-		
+			mair_total = mair_rack;
+			Vair_total = mair_total / ro;
+			
+
+			if(delta_p != -1 && Vair_total != -1)
+				Pfans_dc = delta_p * Vair_total / nf;
+		}
+		return Pfans_dc;
+	}
+	
+	private double calculatePchiller(double Pload_dc, double Pfans_dc, double Pothers, ComputingResource room){
 		
 		double Pchiller = 0;
-		double Pdry_cooler;
-		
-		/*********** Pchiller ***********/
-		double Cp = 1004;//constant
+		
+		Device coolingDevice = null;
+		for(Device device: room.getResourceCharacteristic().getDevices()){
+			if(device.getType().equals(StandardResourceType.CoolingDevice)){
+				coolingDevice = device;
+				break;
+			}
+		}
+		
+		double delta_Th_dry_cooler;//DEBB
+		try{
+			delta_Th_dry_cooler = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("deltaThDryCooler").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			delta_Th_dry_cooler = 10;
+		}
+		
+		double Tamb;//experiment
+		try{
+			Tamb = ConfigurationOptions.coolingData.getAmbientAirTempeature();
+		} catch (Exception e){
+			Tamb = -1;
+		}
 		
 		double ncc;//DEBB
@@ -174,5 +259,5 @@
 			Qcooling_rated = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("coolingCapacityRated").get(0).getContent()).doubleValue();
 		} catch (Exception e){
-			Qcooling_rated = 3000;
+			Qcooling_rated = 80000;
 		}
 		
@@ -183,11 +268,4 @@
 			EERrated = 5;
 		}
-		
-		double Tco;//DEBB
-		try{
-			Tco = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("CWT").get(0).getContent()).doubleValue();
-		} catch (Exception e){
-			Tco = 30;
-		}
 
 		double delta_Th_ex;//DEBB
@@ -197,21 +275,12 @@
 			delta_Th_ex = 10;
 		}
-
-		double Tr_out;//from database, CFD
-		try{
-			Tr_out = ConfigurationOptions.outletRoomAirTempeature;
-		} catch (Exception e){
-			Tr_out = -1;
-		}
 		
 		double Tr_in;//experiment
 		try{
-			Tr_in = ConfigurationOptions.inletRoomAirTempeature;
+			Tr_in = ConfigurationOptions.coolingData.getInletRoomAirTempeature();
 		} catch (Exception e){
 			Tr_in = -1;
 		}
-		
-		double Qdc;
-		double Qcooling;
+
 		
 		double Tev;		
@@ -228,9 +297,12 @@
 		
 		
-		Qdc = mair_total * Cp * (Tr_out - Tr_in);
-		Qcooling = Qdc / ncc;
+		double Qdc = calculateQ(Pfans_dc, Pothers, room);
+		double Qcooling = Qdc / ncc;
 
 		Tev = Tr_in - delta_Th_ex;
 		double Tevf = 32 + 1.8 * Tev;
+		
+		double Tco = Tamb + delta_Th_dry_cooler;
+		
 		double Tcof = 32 + 1.8 * Tco;
 		CoolT = 0.647177 + 0.015888 * Tevf + 0.000103 * Math.pow(Tevf, 2) - 0.004167 * Tcof + 0.000007 * Math.pow(Tcof, 2) - 0.000064 * Tevf * Tcof;
@@ -247,45 +319,61 @@
 		Pchiller = Qcooling/EER;
 
-			
-		
-
-		/*********** Pdry_cooler ***********/
-		double delta_Th_dry_cooler;//DEBB
-		try{
-			delta_Th_dry_cooler = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("deltaThDryCooler").get(0).getContent()).doubleValue();
-		} catch (Exception e){
-			delta_Th_dry_cooler = 10;
-		}
-		
-		double Tamb;//experiment
-		try{
-			Tamb = ConfigurationOptions.ambientAirTempeature;
-		} catch (Exception e){
-			Tamb = -1;
-		}
-		
-		Pdry_cooler = 0.02 * Qcooling;
-		
-		
-		//if data not present in DB than don't take Pchiller into account
-		if(Vair_total != -1 && Tr_in != -1 && Tr_out != -1) {
-			if(Tamb != -1 && Tev - Tamb > 0 && delta_Th_dry_cooler > Tev - Tamb)
-				Pcooling_device = Pdry_cooler;
-			else
-				Pcooling_device = Pchiller;	
-		}
-		
-		
-
-		Pdc = Pload_dc + Pothers + Pfans_dc + Pcooling_device;
-		//System.out.println("---");
-		//System.out.println("Pdry_cooler: " + Pdry_cooler + " Pchiller: "+ Pchiller);
-		//System.out.println("Pdc: " + Pdc + " Pload_dc: "+ Pload_dc + " Pothers: " + Pothers + " Pfans_dc: " + Pfans_dc + " Pcooling_device: " + Pcooling_device);
-		
-		
-		
-		
+		return Pchiller;
+	}
+	
+	private double calculatePdryCooler(double Pload_dc, double Pfans_dc, double Pothers, ComputingResource room){
+
+		double Pdry_cooler = 0;
+		Device coolingDevice = null;
+		for(Device device: room.getResourceCharacteristic().getDevices()){
+			if(device.getType().equals(StandardResourceType.CoolingDevice)){
+				coolingDevice = device;
+				break;
+			}
+		}
+		
+		double n_dry_cooler;//DEBB
+		try{
+			 n_dry_cooler = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("dryCoolerEfficiency").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			 n_dry_cooler = 0.02;
+		}
+
+		double ncc;//DEBB
+		try{
+			ncc = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("coolingCoilEfficiency").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			ncc = 0.95;
+		}
+		
+
+		double Qdc = calculateQ(Pfans_dc, Pothers, room);
+		double Qcooling = Qdc / ncc;
+
+		Pdry_cooler = n_dry_cooler * Qcooling;
+		
+		return Pdry_cooler;
+	}
+	
+	private double calculateQ(double Pfans_dc, double Pothers, ComputingResource room){
+
+		double Qdc = 0;
+		
+		Device coolingDevice = null;
+		for(Device device: room.getResourceCharacteristic().getDevices()){
+			if(device.getType().equals(StandardResourceType.CoolingDevice)){
+				coolingDevice = device;
+				break;
+			}
+		}
+
+		double nf;//DEBB
+		try{
+			nf = Double.valueOf(coolingDevice.getResourceCharacteristic().getParameters().get("CRAHFanEfficiency").get(0).getContent()).doubleValue();
+		} catch (Exception e){
+			nf = 0.6;
+		}
+
 		/**************** HEAT ****************/
-		double Qdc2;
 		
 		double Qload_dc = 0;
@@ -306,40 +394,120 @@
 						Qcpu = Qcpu + proc.getPowerInterface().getRecentPowerUsage().getValue();
 					}
-					double Qfan = 0;
-					for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
-						if(device.getFullName().equals(Node_Fan_Mapping.getNode_fan().get(node.getFullName()))){
-							if(device.getPowerInterface().getRecentPowerUsage().getValue() == -1){
-								Qfan = Qfan + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
-							}else
-								Qfan = Qfan + device.getPowerInterface().getRecentPowerUsage().getValue();
-							break;
+					Qnodes = Qnodes + Qcpu;
+				}
+				double Qfans = 0;
+				for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+					Fan fan = (Fan) device;
+					if(fan.getPowerInterface().getRecentPowerUsage().getValue() == -1){
+						try {
+							Qfans = Qfans + (1 - delta_2) * fan.getAirThroughputInterface().getPowerConsumption(fan.getAirThroughputInterface().getAirThroughputState());
+						} catch (NoSuchFieldException e) {
+							// TODO Auto-generated catch block
+							e.printStackTrace();
+						}
+					}else
+						Qfans = Qfans + (1 - delta_2) * fan.getPowerInterface().getRecentPowerUsage().getValue();
+				}
+				QnodeGroup = QnodeGroup + Qnodes + Qfans;
+			}
+			int nrOfPoweredOffNodes = 0;
+			for(Node node: cb1.getNodes()){
+				if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF)){
+					nrOfPoweredOffNodes++;
+				}
+			}
+			if(nrOfPoweredOffNodes != cb1.getNodes().size()){
+				Qload_dc  = Qload_dc + QnodeGroup + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION;
+			} else {
+				Qload_dc  = Qload_dc + QnodeGroup;
+			}
+		}
+		
+		Qothers = Pothers;
+		
+		Qfans_dc = (1 - nf) * Pfans_dc;
+		
+		Qdc = Qload_dc + Qothers + Qfans_dc;
+
+		
+		return Qdc;
+	}
+	
+	
+	private double calculateQ2(ComputingResource room){
+
+		double Qdc = 0;
+
+		double mair_total;
+		double Vair_total;
+		double ro = 1.168;//constant
+		
+		Vair_total = ConfigurationOptions.coolingData.getAirFlowVolume();
+		
+		if(Vair_total != -1) {
+			mair_total = Vair_total * ro;
+		}
+		else {
+	
+			//in case of DCworms calculation of Vair_total
+			double mair_rack = 0;
+
+			for(ComputingResource cr: room.getChildren()){
+				ComputeBox1 cb1 = (ComputeBox1)cr;
+				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
+					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Outlet)){
+							
+							Fan fan = (Fan) device;
+							double mair_recs = 0;
+							double Vair_recs = 0;
+							
+							double Vair_recs1 = 0;
+
+							Vair_recs1  = fan.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+							double Vair_recs2 = 0;
+							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
+								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){
+
+									Vair_recs2  = device2.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+									break;
+								}
+							}	
+
+							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
+
+							mair_recs = Vair_recs * ro;
+							mair_rack  = mair_rack + mair_recs;
 						}
 					}
-					Qnodes = Qnodes + Qcpu + (1 - delta_2) * Qfan;
 				}
-				QnodeGroup = QnodeGroup + Qnodes;
-			}
-			Qload_dc  = Qload_dc + QnodeGroup;
-		}
-		
-		Qload_dc = Qload_dc + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION;
-		
-		Qothers = Pothers;
-		
-		Qfans_dc = (1 - nf) * Pfans_dc;
-		
-		Qdc2 = Qload_dc + Qothers + Qfans_dc;
-		
-		double Qdc2v2 = 0;
-		
-		if(Vair_total != -1 && Tr_in != -1 && Tr_out != -1)
-			Qdc2v2 = mair_total * Cp * (Tr_out - Tr_in);
-
-		//System.out.println("Qdc2: " + Qdc2 + " Qdc2v2: " + Qdc2v2 + "diff: " + (Qdc2v2 - Qdc2));
-
-		
-		return Pdc;
-	}
-	
-
+			}
+			mair_total = mair_rack;
+		}
+		
+		double Cp = 1004;//constant
+
+
+		double Tr_out;//from database, CFD
+		try{
+			Tr_out = ConfigurationOptions.coolingData.getOutletRoomAirTempeature();
+		} catch (Exception e){
+			Tr_out = -1;
+		}
+		
+		double Tr_in;//experiment
+		try{
+			Tr_in = ConfigurationOptions.coolingData.getInletRoomAirTempeature();
+		} catch (Exception e){
+			Tr_in = -1;
+		}
+
+
+		Qdc = mair_total * Cp * (Tr_out - Tr_in);
+		
+		return Qdc;
+	}
+	
 }
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpOutletEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpOutletEnergyEstimationPlugin.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpOutletEnergyEstimationPlugin.java	(revision 1299)
@@ -1,5 +1,11 @@
 package example.energy.coolemall;
 
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.coolemall.ComputeBox1;
+import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.devices.Device;
+import schedframe.resources.devices.Fan;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -21,12 +27,53 @@
 		double Vair_total;
 		
-		try{
-			Vair_total = ConfigurationOptions.airFlowVolume;
-		} catch (Exception e){
-			Vair_total = 0;
+		Vair_total = ConfigurationOptions.coolingData.getAirFlowVolume();
+		if(Vair_total != -1) {
+			airThroughput = Vair_total;
+		} else {
+			Device flowPump = (Device) resource;
+			ComputingResource room = flowPump.getComputingResource();
+
+			double ro = 1.168;//constant
+			
+			double mair_total;
+			double mair_rack = 0;
+
+			for(ComputingResource cr: room.getChildren()){
+				ComputeBox1 cb1 = (ComputeBox1)cr;
+				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
+					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Outlet)){
+							
+							Fan fan = (Fan) device;
+							double mair_recs = 0;
+							double Vair_recs = 0;
+							
+							double Vair_recs1 = 0;
+
+							Vair_recs1  = fan.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+							double Vair_recs2 = 0;
+							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
+								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){
+
+									Vair_recs2  = device2.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+									break;
+								}
+							}	
+
+							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
+
+							mair_recs = Vair_recs * ro;
+							mair_rack  = mair_rack + mair_recs;
+						}
+					}
+				}
+			}
+			mair_total = mair_rack;
+			Vair_total = mair_total / ro;
+			airThroughput = Vair_total;
 		}
-		airThroughput = Vair_total;
 		return airThroughput;
 	}
-
 }
